# BlueBubbles Android App

BlueBubbles is an open-source and cross-platform ecosystem of apps aimed to bring iMessage to Android, Windows, Linux, and more! With BlueBubbles, you'll be able to send messages, media, and much more to your friends and family.

**Please note that BlueBubbles requires a Mac and an Apple ID to function! A macOS VM on Windows or Linux can suffice as well.

Key Features:

- Send & receive texts, media, and location
- View tapbacks, reactions, and stickers
- Create new chats (macOS 11+ has limited support while macOS 10 has full support)
- View read/delivered timestamps
- Mute or archive conversations
- Robust theming engine
- Choose between an iOS or Android-style interface
- Lots of customizations and options to personalize your experience

Private API Features:

- Send tapbacks
- See typing indicators
- Send read receipts

**Private API Features are not enabled by default and require extra configurations. Details can be found in the settings page of the app.**

If you need help setting up the app, have any issues or feature requests, or just want to come hang out, feel free to join our Discord, linked below! We hope you enjoy using the app!

## Useful links

* Our Website: [here](https://bluebubbles.app)
* Discord: [here](https://discord.gg/4F7nbf3)!
    - We highly encourage users to join to get in direct communication with the developers and community
* GitHub: [here](https://github.com/BlueBubblesApp)
    - Please submit any issues with the app here so we can properly track them! Remember to search before opening a ticket :)
    - Contribution is *always* appreciated and needed! Feel free to download our source, make changes, and submit a pull request.

## Getting Started

All Android builds can be found in [here](https://github.com/BlueBubblesApp/BlueBubbles-Android-App/releases).

All Server builds can be found in [here](https://github.com/BlueBubblesApp/BlueBubbles-Server/releases).

After downloading both, follow our tutorial [here](https://bluebubbles.app/install/).

## Contributing

Please check out our contribution guide here: [Contribution Guide](https://github.com/BlueBubblesApp/BlueBubbles-Android-App/wiki/Contribution-Guide)
